[![ubuntu 🐧](https://github.com/HorusElohim/TheBundle/actions/workflows/python-ubuntu.yml/badge.svg?branch=main)](https://github.com/HorusElohim/TheBundle/actions/workflows/python-ubuntu.yml)
[![macos 🍏](https://github.com/HorusElohim/TheBundle/actions/workflows/python-darwin.yml/badge.svg)](https://github.com/HorusElohim/TheBundle/actions/workflows/python-darwin.yml)
[![windows 🪟](https://github.com/HorusElohim/TheBundle/actions/workflows/python-windows.yml/badge.svg)](https://github.com/HorusElohim/TheBundle/actions/workflows/python-windows.yml)
[![PyPI Release 🐍](https://github.com/HorusElohim/TheBundle/actions/workflows/publish-pypi.yml/badge.svg)](https://github.com/HorusElohim/TheBundle/actions/workflows/publish-pypi.yml)
[![auto reference update 🔄](https://github.com/HorusElohim/TheBundle/actions/workflows/auto-reference-update.yml/badge.svg)](https://github.com/HorusElohim/TheBundle/actions/workflows/auto-reference-update.yml)

# THE BUNDLE

![The Bundle Dream](thebundle.png)


## Getting Started

Embark on your BUNDLE journey:
1. Install BUNDLE: `pip install thebundle`
2. Explore our extensive documentation for more insights.
3. Experiment with our test suite to see BUNDLE in action.


Welcome to BUNDLE, a comprehensive Python package designed to enhance various aspects of coding, from data handling and entity management to process control and task execution. BUNDLE streamlines complex tasks, offering robust and efficient solutions for both synchronous and asynchronous operations.

### [data](src/bundle/core/data/README.md)
The data subpackage provides advanced data handling capabilities, focusing on easy conversions between Python data classes and dictionaries, JSON serialization/deserialization, and JSON schema validations.

### [entity](src/bundle/core/entity/README.md)
This subpackage introduces an advanced Entity class, an enhanced data structure that serves as a base for developing more complex classes with additional features like lifecycle timestamps and auto-saving capabilities.

### [tasks](src/bundle/core/tasks/README.md)
This subpackage is dedicated to task management and execution. It includes classes for both synchronous and asynchronous task execution, extending these functionalities to a variety of use cases.

### [process](src/bundle/core/process/README.md)
The process subpackage offers sophisticated process handling capabilities, ideal for managing and interacting with system processes in both synchronous and asynchronous contexts.


### Testing and Tools
BUNDLE is equipped with a comprehensive testing suite, ensuring reliability and stability across its functionalities. The tests cover all aspects of the package, from data handling to process management.

*tests/tools:* Contains various utility functions and tools to support testing, including assertions, profiling, and more.

## License
BUNDLE is open-sourced under the APACHE-V2 License.

## Join the BUNDLE Revolution!

Step into the future of Python development with BUNDLE. Redefine what's possible with your code.
